/* Boards/AT91/BoardDefines.h
Defines various constants and macros for the AT91

19/Feb/1999 ned
*/

/* KEEP CONSISTENT WITH BoardDefinesH.s */


/* Number of handlers for each exception */
#define UndefinedExcptHandlers	2
#define SWIExcptHandlers		2
#define PAbortExcptHandlers		2
#define DAbortExcptHandlers		2
#define IRQExcptHandlers		2
#define FIQExcptHandlers		2

/* Constants - Exception related */
#define ResetV	0
#define UndefV	1
#define SWIV	2
#define PAbortV	3
#define DAbortV	4
#define IRQV	6
#define FIQV	7

/*; Sizes of the processor mode stacks */
#define IRQ32StackSize		4096
#define FIQ32StackSize		1024
#define Abort32StackSize	1024
#define Undef32StackSize	1024
#define SVC32StackSize		8192
#define BOARD_TOTALSTKSSIZE	IRQ32StackSize + FIQ32StackSize + Abort32StackSize + Undef32StackSize + SVC32StackSize

/* Location of exception handlers */
#define BOARD_EXCEPTHLOCATION		0x0
/* Location of HAL r/w data */
#define BOARD_HALZPLOCATION			0xc0
/* Location of UART ctrl blks */
#define BOARD_HALZP_UARTSPACE		0x800				/* 2k */
/* Location of L1 MMU page tables */
/*#define BOARD_ARMMMU_L1PAGETABLES	0x4000	*/			/* 16k (16k of L1 page tables) */
#ifdef STANDALONE
#define BOARD_HALSTKSLOCATION		0x0207c000			/* End of DRAM (16k) */
#define BOARD_HALZP_SIZEOF			0x1000				/* 4k */
#else
/* Where we put the processor stacks */
#define BOARD_HALSTKSLOCATION		0x8000				/* 32k (16k) */
#define BOARD_HALZP_SIZEOF			0x10000				/* 64k */
#endif

/* Locations of UART zero page locations */
#define ANGELUARTID		0
#define HALZP_ANGELUARTSPACE		(ANGELUARTID * sizeof(HALUARTBlk))
#define DEMONUARTID		1
#define HALZP_DEMONUARTSPACE		(DEMONUARTID * sizeof(HALUARTBlk))
#define AT91AUARTID		2
#define AT91AUARTADDR	(void *) 0xFFFD0000
#define HALZP_AT91AUARTSPACE		(AT91AUARTID * sizeof(HALUARTBlk))
#define AT91BUARTID		3
#define AT91BUARTADDR	(void *) 0xFFFCC000
#define HALZP_AT91BUARTSPACE		(AT91BUARTID * sizeof(HALUARTBlk))
#define HALZP_UARTSPACE(zp, id)		(HALUARTBlk *)((int) zp + BOARD_HALZP_UARTSPACE + id*sizeof(HALUARTBlk))

/* This macro is called to return the location of the zero page memory
   NOTE: This gets called in the general ISR so make it quick!
   It returns a pointer to 64k of zero page memory in R0 */
#ifdef STANDALONE
#define BOARD_RETURNZPLOCATION() (HALZeroPage *)(0x0)
#else
#define BOARD_RETURNZPLOCATION() (HALZeroPage *)(0x02080000 - 0x10000)		/* 64k before mem end */
#endif
