; UARTs/Demon/driver.s
; Demon UART driver
;
; 16/Nov/1999 ned


	
	AREA	DemonUARTDriver, CODE, READONLY

	; Include common includes
	INCLUDE	CommonH.s

	[ :DEF: DEMON

	; Exports from this module
	EXPORT	DemonUARTDriver_Initialise
	EXPORT	DemonUARTDriver_Finalise
	EXPORT	DemonUARTDriver_WriteN
	EXPORT	DemonUARTDriver_ReadN

DemonUARTDriver_Initialise
	; R0=ptr to UART block
	; R1=addr of UART (not applicable here)
	; R2=uart id (not applicable here)
	STR	R1,[R0,#HALUARTBLK_UARTADDR]
	MOV	R0,#0
	MOV	PC,R14

DemonUARTDriver_Finalise
	; R0=ptr to UART block
	STMFD	R13!,{R1}
	MOV	R1,#0
	STR	R1,[R0,#HALUARTBLK_UARTADDR]
	MOV	R0,#0
	LDMFD	R13!,{R1}
	MOV	PC,R14

DemonUARTDriver_WriteN
	; R0=ptr to UART block
	; R1=ptr to ASCII string
	; R2=chars to write
	STMFD	R13!,{R1-R3}
1
	LDRB	R0,[R1],#1
	SWI		0x0				; OS_WriteC
	SUBS	R2,R2,#1
	BNE		%b01
	MOV		R0,#0			; no error
	LDMFD	R13!,{R1-R3}
	MOV		PC,R14

DemonUARTDriver_ReadN
	; R0=ptr to UART block
	; R1=ptr to buffer
	; R2=chars to read
	STMFD	R13!,{R1-R3}
1
	SWI		0x4				; OS_ReadC
	STRB	R0,[R1],#1
	SUBS	R2,R2,#1
	BNE		%b01
	MOV		R0,#0
	LDMFD	R13!,{R1-R3}
	MOV		PC,R14

	]
	END
