/* ARM/NedHAL_Entry.c
Entry point of NedHAL into UCOS

2nd November 1999 ned
*/

#include "NedHAL.h"

#ifdef __cplusplus
extern "C" {
#endif

static int ISR(int param)
{
	OSIntEnter();

	DbgIO_Write0("Interrupt service routine called\n\n");

	OSTimeTick();

	OSIntExit();

	/* Indicate we claimed the interrupt */
	return 1;	
}

extern void NedHAL_Entry(void)
{
	HALError *ret;
	DbgIO_Write0("NedHAL_Entry called\n\n");

	// Install IRQ Handler for UCOS
	ret=IRQH_AddHandler(ISR, 5, 0);

	// Call main()
	{
		int ret;
		ret=main();
	}
}

#ifdef __cplusplus
}
#endif
